// This file is part of Substrate.

// Copyright (C) Parity Technologies (UK) Ltd.
// SPDX-License-Identifier: Apache-2.0

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// 	http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

//! # FRAME Pallet Examples
//!
//! This crate contains examples of FRAME pallets. It is not intended to be used in production.
//!
//! ## Pallets
//!
//! - [**`pallet_example_basic`**](./basic): A simple example of a FRAME pallet demonstrating
//! concepts, APIs and structures common to most FRAME runtimes.
//!
//! - [**`pallet_example_offchain_worker`**](./offchain-worker): A simple example of a FRAME pallet
//!   demonstrating concepts, APIs and structures common to most offchain workers.
//!
//! - [**`pallet-default-config-example`**](./default-config): A simple example of a FRAME pallet
//!   demonstrating the simpler way to implement `Config` trait of pallets.
//!
//! - [**`pallet-dev-mode`**](./dev-mode): A simple example of a FRAME pallet demonstrating the ease
//!   of requirements for a pallet in dev mode.
//!
//! - [**`pallet-example-kitchensink`**](./kitchensink): A simple example of a FRAME pallet
//!   demonstrating a catalog of the the FRAME macros and their various syntax options.
//!
//! - [**`pallet-example-split`**](./split): A simple example of a FRAME pallet demonstrating the
//!   ability to split sections across multiple files.
